*---------------------------------------------------------------------------------------------------------------------
* GAMS OPTIONS
*---------------------------------------------------------------------------------------------------------------------
*
option Reslim=80000000;
option profile=10;

* ------------------------------------------------------------------------------
* CPU time
* ------------------------------------------------------------------------------
scalar startT;
scalar endT;
scalar elapsed;

*-------------------------------------------------------------------------------
* INPUT/OUTPUT FILES
*-------------------------------------------------------------------------------
*
$include defINOUT_MV.gms

* ------------------------------------------------------------------------------
* USER OPTION
* ------------------------------------------------------------------------------

Scalar fdayguasti;
fdayguasti=1;

* ------------------------------------------------------------------------------
* STATIC DATA (SYSTEM DATA)
* ------------------------------------------------------------------------------
* INI HOURS
Set HOURS Hours /1*8760/;

Scalar nHOURS;
nHOURS=card(HOURS);


* INI Areas --------------------------------------------------------------------
*
Set
      NAREE Areas                   /
$include %pathIN%\aree.inc
                                    /;


Set
      NG  Generators                /
$include %pathIN%\generatori.inc
                                    /;

* INI Generators ---------------------------------------------------------------
*

* G_TO_AREA: 1 generator --> 1 area
Set G_TO_AREA(NG,NAREE) Generator-Area /
$include %pathIN%\genToArea.inc
                                        /;

* outages data
Set LabelG_DEGPOT_GUAS Par gen guasti data label /MTTF,MTTR,N_GR,GR_0,DR_0,GR_1, DR_1,GR_2, DR_2,GR_3, DR_3,GR_4, DR_4/;
Table G_TO_PAR_GU(NG, LabelG_DEGPOT_GUAS) Generator outages parameter
$ondelim
$include %pathIN%\guastoTot.csv
$offdelim
;

Set G_UNAVAIL(HOURS, NG);

Parameter PG_MSD(HOURS, NG), PG_UP(HOURS,NG);
Parameter PMSD_LOSS(HOURS,NG), PMSD_LOSS_TOT(NG);
Parameter P_DEG_dummy, P_DEG(HOURS,NG);
PG_MSD(HOURS,NG)=100;
PG_UP(HOURS,NG)=110;

* ------------------------------------------------------------------------------
* Outages
* ------------------------------------------------------------------------------
scalar tini,tifi;
scalar lambdaIN;
scalar lambdaOUT;
scalar u;

option seed=99883;

Set oreGuasto(HOURS);

Scalar rndm_p;
rndm_p=0;
Scalar day_guasto;
day_guasto=0;


*---------------------------------------------------------------------------------------------------------------------
* OUTPUT CASE DIMENSIONS
*---------------------------------------------------------------------------------------------------------------------
*
put screen;
put ' ', put /;
put ' ***************************************************************************', put /;
put ' ', put /;
put ' Case summary: '/;
put ' ', put /;
put '      Areas                   = ', put card(NAREE):0:0,        put /;
put '      Generators              = ', put card(NG):0:0,           put /;
put ' ', put /;
put ' ***************************************************************************', put /;
putclose;

put remlog;
put ' ***************************************************************************', put /;
put ' ', put /;
put ' Case summary: '/;
put ' ', put /;
put '      Areas                   = ', put card(NAREE):0:0,        put /;
put '      Generators              = ', put card(NG):0:0,           put /;
put ' ', put /;
put ' ***************************************************************************', put /;
putclose;

Set AC /AC01/;
Set SAMPLES /MC01/;

Scalar versione;
versione=2;

loop(AC,
         loop(SAMPLES,
startT = jnow;
$include guastoGen_MV.gms
         );
endT= jnow;
elapsed = (endT - startT)*24*3600;

put screen;
put ' (elapsed [s]: '; put elapsed:0:10; put ')'; put /;
putclose;

put remlog;
put ' (elapsed [s]: '; put elapsed:0:10; put ')'; put /;
putclose;

);

